---
title: 扩展消息
sidebar_position: 180
---

# 扩展消息

已发送的超级群消息可增加、修改、删除扩展信息。

**适用场景**：

原始消息增加状态标识的需求，都可使用消息扩展。

- 消息评论需求，可通过设置原始消息扩展信息的方式添加评论信息。
- 礼物领取、订单状态变化需求，通过此功能改变消息显示状态。 例如：向用户发送礼物，默认为未领取状态，用户点击后可设置消息扩展为已领取状态。

:::tip

 - 每次设置消息扩展将会产生内置通知消息，频繁设置扩展会产生大量消息。
 - 仅当发送消息时指定 `canIncludeExpansion` 值为 `true`，才可对消息进行扩展。
:::


## 设置、更新消息扩展信息

:::tip

 消息扩展功能要求在发送消息前设置该消息为可扩展消息。关于如何修改消息的的可扩展属性，请参考[消息扩展](../message/expansion.md)中的对 `setCanIncludeExpansion()` 的说明。
:::


```java
class OperationCallback {
	onSuccess()
  onError(ErrorCode code)
}

//更新消息扩展
public void updateUltraGroupMessageExpansion(final Map<String, String> expansion, final String messageUId, final IRongCoreCallback.OperationCallback callback)

//删除消息扩展
public void removeUltraGroupMessageExpansion(final String messageUId, final List<String> keyArray, final IRongCoreCallback.OperationCallback callback)
```

## 监听消息处理

```java
//超级群消息变化通知
interface UltraGroupMessageChangeListener {
  //消息扩展更新，删除
  void onUltraGroupMessageExpansionUpdated(List<Message> messages);
  //消息内容发生变更
  void onUltraGroupMessageModified(List<Message> messages);
  //消息撤回
  void onUltraGroupMessageRecalled(List<Message> messages);
}

//设置超级群消息变化监听
public void setUltraGroupMessageChangeListener(IRongCoreListener.UltraGroupMessageChangeListener listener)

```

